/****************************************************************/
/*  
     ***   ***  ***  *** ***     *** ***   ******  ****  ***
     ***   ***  ***  *** ***     *** **   ***  *** ***** ***
     ***   ***  ***  *** ***     *****    ******** *** *****
      *** ***   ***  *** ******* *** **   ***  *** ***  ****
       *****     *****   ******* *** ***  ***  *** ***   ***
	   
	 Vulkan Graphics API: in 20 Minutes (Coffee Break Series)
	 Beginners Taste

     Minimal working examples (MWE) to build upon and 
	 modify to gain an understanding of the API

	 Extensions to the Vulkan Graphics Coffee Break Series
	   
/*
/****************************************************************/


#version 420


layout (binding = 1) uniform sampler2D samplerColor[15];

layout (location = 0) in vec3 inNormal;
layout (location = 1) in vec3 inColor;
layout (location = 2) in vec3 inEyePos;
layout (location = 3) in vec3 inLightVec;
layout (location = 4) in vec2 inUV;
layout (location = 5) flat in uint inMatId;

layout (location = 0) out vec4 outFragColor;



void main() 
{
	vec3 Eye = normalize(-inEyePos);
	vec3 Reflected = normalize(reflect(-inLightVec, inNormal)); 

	vec4 IAmbient = vec4(0.1, 0.1, 0.1, 1.0);
	vec4 IDiffuse = vec4(max(dot(inNormal, inLightVec), 0.0));
	float specular = 0.75;
	vec4 ISpecular = vec4(0.0);
	if (dot(inEyePos, inNormal) < 0.0)
	{
		ISpecular = vec4(0.5, 0.5, 0.5, 1.0) * pow(max(dot(Reflected, Eye), 0.0), 16.0) * specular; 
	}

	if ( inMatId > 15 )
	{
		outFragColor = vec4((IAmbient + IDiffuse) * vec4(inColor, 1.0) + ISpecular);
	}
	else
	{
		vec4 texColor = texture(samplerColor[ inMatId ], inUV);
		outFragColor = vec4((IAmbient + IDiffuse) * texColor + ISpecular);
	}

}